<script setup lang="ts">
  type Props = {
    name: string;
    price: number;
    oldPrice?: number;
    options?: string;
    image: string;
  };

  defineProps<{
    data: Props;
    loading?: boolean;
    readonly?: boolean;
  }>();

  const emits = defineEmits<{
    (e: 'click'): void;
    (e: 'remove'): void;
  }>();

  const { getFormattedPrice } = usePrice();

  // const productRemoved = ref(false);
  // const $cardItem = ref();
  // const styleObject = ref({});

  const handleDefaultAction = () => {
    emits('click');
  };

  const handleRemove = () => {
    emits('remove');
  };

  // const handleUndo = () => {
  //   productRemoved.value = false;
  //   console.log('handleUndo');
  // };
</script>

<template>
  <!-- <div
    v-if="productRemoved"
    class="flex h-40 flex-col items-center justify-center gap-2 border-b"
    :style="styleObject"
  >
    <div class="text-sm font-medium">
      {{ $t('cart.productRemoved') }}
    </div>
    <SwButton variant="action" class="w-max" @click="handleUndo()">
      <span class="i-sw-solid:undo text-sm" />
      {{ $t('undo') }}
    </SwButton>
  </div> -->

  <div class="relative flex w-full gap-3 border-b px-0 py-6">
    <SwLoading
      v-if="loading"
      class="z-loading text-primary absolute inset-0 bg-white/60 text-2xl"
    />
    <slot name="product-image">
      <div
        class="border-border-default h-20 w-20 shrink-0 grow-0 overflow-hidden rounded-md border"
      >
        <img
          :src="data.image"
          class="aspect-product-standard-thumbnail cursor-pointer object-cover"
          @click="handleDefaultAction"
        />
      </div>
    </slot>

    <div class="flex shrink grow flex-col justify-between">
      <div class="flex justify-between gap-5">
        <div>
          <slot name="product-name">
            <h3
              class="text-(sm information-dark) hover:text-primary line-clamp-2 cursor-pointer font-semibold"
              @click="handleDefaultAction"
            >
              {{ data.name }}
            </h3>

            <h6 v-if="data.options">{{ data.options }}</h6>
          </slot>
        </div>

        <slot name="remove-button">
          <SwButton
            v-if="!readonly"
            variant="action"
            class="flex h-7 w-7 items-center justify-center"
            @click="handleRemove"
          >
            <span class="i-sw-solid:times-s text-sm" />
          </SwButton>
        </slot>
      </div>

      <div class="flex items-center justify-between gap-1">
        <div class="flex h-8 min-w-0 gap-1">
          <slot name="product-meta">
            <div />
          </slot>
        </div>
        <div class="flex-1 text-right" style="overflow-wrap: anywhere">
          <slot name="product-price">
            <div class="flex flex-col items-end">
              <span
                class="text-sm/6 font-bold"
                :class="{ 'text-danger': data.oldPrice !== undefined }"
              >
                {{ getFormattedPrice(data.price, true) }}
              </span>
              <span v-if="data.oldPrice !== undefined" class="text-[9px] line-through">
                {{ getFormattedPrice(data.oldPrice, true) }}
              </span>
            </div>
          </slot>
        </div>
      </div>
    </div>
  </div>
</template>
